#import "@preview/wrap-it:0.1.1": *

== Backups

#figure(
  image("../../images/backup-overview.png", width: 100%),
)

Backups sind automatisch gesicherte Datenstände des FF Admin, die jederzeit wiederhergestellt werden können. Diese Backups sind nicht an ein bestimmtes Datenbanksystem gebunden und können daher jederzeit auf eine andere Plattform übertragen werden.

Backups werden in einem festgelegten Intervall erstellt. Das kleinste Intervall beträgt täglich. Zusätzlich kann konfiguriert werden, wie viele Backups parallel zur Verfügung stehen sollen. Standardmäßig ist eine Anzahl von 7 eingestellt, d.h. die gespeicherten Backups reichen immer eine Woche in die Vergangenheit.

Eine Funktion, die mit den Backups eingeführt wurde, ist `AUTO RESTORE`. `AUTO RESTORE` ermöglicht die automatische Wiederherstellung des letzten Backups - sofern vorhanden - wenn die Datenbank beim Start des Servers leer ist. Dies vereinfacht auch den Wechsel zwischen Datenbanken, da nur eine neue Verbindung zu einer anderen Datenbank aufgebaut werden muss und die Daten nach dem Neustart des Servers automatisch in die neue leere Datenbank übertragen werden.
\
\
#wrap-content(
  figure(
    image("../../images/backup-restore.png", width: 6.5cm),
  ),
)[
Derzeit können Backups nur vollständig wiederhergestellt werden. Dabei werden alle vorhandenen Daten gelöscht und durch die Daten des Backups ersetzt. Dadurch wird automatisch ein früherer Zustand wiederhergestellt. Neuere Einträge gehen dabei verloren.

Ein teilweises Wiederherstellen oder nur Ersetzen von Einträgen unter Beibehaltung der neu hinzugekommenen Einträge ist derzeit nicht möglich, da dies derzeit noch zu Datenverlusten führen kann. Weitere Konfigurationsmöglichkeiten befinden sich in der Entwicklung.
]

#wrap-content(
  figure(
    image("../../images/backup-upload.png", width: 6.5cm),
  ),
  align: right
)[
Heruntergeladene Backups können jederzeit wieder hochgeladen und im Admin gespeichert werden. Im Gegensatz zu den automatisch erstellten Backups sind die Slots nicht begrenzt. Es können also beliebig viele Backups hochgeladen und gespeichert werden.

Es ist geplant, "Backups" mit Basisdaten zur Verfügung zu stellen. Diese können dann in FF Admin hochgeladen und verwendet werden. Dazu muss allerdings die Funktion der Teil-Wiederherstellung funktionieren, da sonst Daten gelöscht werden.
]